Subject: Copy of reserved bits from SYN into SYN-ACK

From: Reiner Ludwig <[email-masked]>
Date: Tue, 30 Oct 2001 14:18:01 +0100

Hi,

does anybody know if there are TCP implementations out there *today* that 
simply copy the bits of the TCP Reserved field from the SYN into the SYN-ACK?

This is relevant when thinking about how to negotiate the use of a single 
bit from the TCP Reserved field assuming that it would be allocated at some 
point in the future.

///Reiner

---

From: Andi Kleen <[email-masked]>
Date: Tue, 30 Oct 2001 15:56:13 +0100

> simply copy the bits of the TCP Reserved field from the SYN into the SYN-ACK?

Older Linux does that.

-Andi

---

From: Alan Cox <[email-masked]>
Date: Tue, 30 Oct 2001 15:05:34 +0000 (GMT)

> simply copy the bits of the TCP Reserved field from the SYN into the SYN-ACK?

Afraid so. Unfortunately I'm kind of the guilty party who let it out 8(

> bit from the TCP Reserved field assuming that it would be allocated at some 

Linux 2.0.x has this problem (2.2/2.4 behave) and there are still 2.0 boxes
around.

Alan

---

From: Joe Touch <[email-masked]>
Date: Tue, 30 Oct 2001 11:48:24 -0800

Reiner Ludwig wrote:

> Hi,
> 
> does anybody know if there are TCP implementations out there *today* 
> that simply copy the bits of the TCP Reserved field from the SYN into 
> the SYN-ACK?
> 
> This is relevant when thinking about how to negotiate the use of a 
> single bit from the TCP Reserved field assuming that it would be 
> allocated at some point in the future.

Notably about ECN - ECN requires that a non-ECN receiver respond with 
all-zeroes ECN bits. Copying the bits on the return path is a violation 
of ECN -

(Page 14):
  * If a host has received an ECN-setup SYN packet, then it MAY send
         an ECN-setup SYN-ACK packet.  Otherwise, it MUST NOT send an
         ECN-setup SYN-ACK packet.

Joe